package celular;

/**
  * Universidade Federal de Pernambuco
  * Centro de Informtica
  * Disciplina: Introducao a Programao
  * Projeto Celular
  *
  * Tipo: PrevisaoDeTexto
  *
  * @author: Alberto Csar C. Frana     (accf2@cin.ufpe.br)
  * @author: Luciana Pereira Oliveira    (lpo@cin.ufpe.br)
  *
  * @since 2002
  * @version 1.0
  **/

import celular.palavras.*;

public class PrevisaoDeTexto implements IPrevisaoDeTexto {

    private CadastroDePalavras vocabulario;

    public PrevisaoDeTexto(CadastroDePalavras c){
    	this.vocabulario = c;
    }

    public PrevisaoDeTexto(){
    	this.vocabulario = new CadastroDePalavras(new ListaDePalavras());
    }

  /**  Metodo que insere uma palavra no vocabulario
   *   @param palavra        recebe uma palavra do tipo Palavra
   */
   public void inserir(Palavra palavra) {
      vocabulario.inserir(palavra);
   }

  /** Metodo que exclui um palavra do vocabulario
   *   @param palavra        recebe o nome da palavra do tipo Palavra
   */
   public void excluir(Palavra palavra){
          vocabulario.excluir(palavra);
   }

   public boolean existe(Palavra palavra) {
          return vocabulario.existe(palavra);
   }

   public ListaDePalavras filtrar(char[] letras,int posicaoAtual){
     return vocabulario.filtrar(letras,posicaoAtual);
   }
}