package celular.palavras;

/**
  * Universidade Federal de Pernambuco
  * Centro de Informtica
  * Disciplina: Introducao a Programao
  * Projeto Celular
  *
  * Tipo: CadastroDePalavras
  *
  * @author: Alberto Csar C. Frana     (accf2@cin.ufpe.br)
  * @author: Luciana Pereira Oliveira    (lpo@cin.ufpe.br)
  *
  * @since 2002
  * @version 1.0
  **/

import celular.util.Console;

public class CadastroDePalavras {
  private ListaDePalavras palavras;

  /** Construtor
	 * @param lista   do tipo Lista
   */

  public CadastroDePalavras(ListaDePalavras l) {
    if (l != null) {
      palavras = l;
    } else {
      new Console().println("ERRO: A lista passada como parametro nao eh valida");
    }
  }

  /** Metodo que insere um palavra em dicionario
   *   @param palavra        recebe uma palavra do tipo Palavra
   */
  public void inserir(Palavra palavra) {
      if (palavra != null){
        if (!palavras.existe(palavra))  {
           this.palavras.inserir(palavra);
        } else {
            new Console().println("ERRO: a palavra jah existe!");
        }
      } else {
        new Console().println("ERRO: A palavra passada como parametro nao eh valida");
      }
   }

  /** Metodo que exclui um palavra do dicionario
   *   @param palavra        recebe o nome da palavra do tipo Palavra
   */
   public void excluir(Palavra palavra) {
      if (palavra != null){
          this.palavras.excluir(palavra);
      } else {
        new Console().println("ERRO: A palavra passada como parametro nao eh valida");
      }
   }

   /** Metodo verifica se o palavra recebido por parametro existe na
	 *   no dicionario
	 *
   *   @param palavra        recebe uma palavra do tipo String
   *   @return               true se a palavra dada existe no Dicionario
   */
   public boolean existe(Palavra palavra) {
          return this.palavras.existe(palavra);
   }

    /**
   * metodo que verifica qual a tecla clicada e chama o metodo
   * provaveisPalavra passando letras que a
   * o numero da tecla representa e a posicao da letra nas palavras
   *
   * @param    tecla  do tipo int
   * @param    posicao do tipo int
   */

   public ListaDePalavras filtrar(char[] letras,int posicaoAtual){
     return palavras.filtrar(letras,posicaoAtual);
   }

  public void reset() {
    this.palavras.reset();
  }

  public Palavra proxima() {
    return this.palavras.proxima();
  }

    //main para verificacao de alguns metodos
    public static void main(String args[]){
      Console c = new Console();
      CadastroDePalavras  r = new CadastroDePalavras(new ListaDePalavras());
      ListaDePalavras temp;
    	r.inserir(new Palavra("bola"));
      r.inserir(new Palavra("bolada"));
    	r.inserir(new Palavra("bolo"));
    	r.inserir(new Palavra("dado"));
    	r.inserir(new Palavra("dedo"));
      r.inserir(null);
    	c.println("Existe bolo : " + r.existe(new Palavra("bolo")));

    	c.println("\nPalavras Existentes:");

      r.reset();
      Palavra p = r.proxima();
      while(p != null){
          c.println(p.getPalavra());
          p = r.proxima();
    	}

      r.excluir(new Palavra("bolo"));
    	c.println("\nExiste bolo : " + r.existe(new Palavra("bolo")));
      r.excluir(null);
      char[] letras = {'a','b','c'};
      r = new CadastroDePalavras(r.filtrar(letras,1));
      r.reset();
      p = r.proxima();
      while(p != null){
      		c.println(p.getPalavra());
          p = r.proxima();
    	}
      //c.readString();
    }
}
