package celular.palavras;

/**
  * Universidade Federal de Pernambuco
  * Centro de Informtica
  * Disciplina: Introducao a Programao
  * Projeto Celular
  *
  * Tipo:Palavra
  *
  * @author: Alberto Csar C. Frana     (accf2@cin.ufpe.br)
  * @author: Luciana Pereira Oliveira    (lpo@cin.ufpe.br)
  *
  * @since 2002
  * @version 1.0
  **/

import celular.util.Console;

public class Palavra {

  private String palavra;

  /** Construtor
   *  @param   palavra   do tipo String
   */
  public Palavra(String palavra) {
    if (palavra != null){
       this.palavra = palavra;
    } else {
        Console c = new Console();
        c.println("ERRO: a palavra passada como parametro eh nula");
    }
  }

  /** Metodo que retorna a palavra propriamente dita(o string)
  	* @return palavra        do tipo String
  	*/
  public String getPalavra(){
    return this.palavra;
  }

  /** Metodo que verifica se a palavra que
    * chama o metodo eh igual que a palavra passada como
    * parametro
  	* @boolean retorno        retorna a verificacao
  	*/
  public boolean equals(Palavra p){
    boolean retorno = false;
    if (p.getPalavra().equalsIgnoreCase(this.getPalavra())){
          retorno = true;
    }
    return retorno;
 }

 /** Metodo que verifica se a palavra que
    * possui palavra chave que foi passada como parametro
  	* @boolean retorno        retorna a verificacao
  	*/
 public boolean temLetras(char[] letras,int posicao){
 	boolean retorno = false;
        char l = this.getLetra(posicao);
 	if (l!='\n') {
 	  for (int i = 0; i < letras.length; i++) {
            retorno = retorno || (l == letras[i]);
          }
 	}
 	return retorno;
 }

 /** Metodo que retorna uma letra que esta na posicao
    * passada como parametro
  	* @param  posicao       do tipo int
  	* @return char          retorna letra do tipo char
  	*/
 private char getLetra(int posicao){
 	char letra = '\n';
 	if(posicao<=this.palavra.length()){
 		letra = this.palavra.charAt(posicao-1);
 	}
 	return letra;
 }

 //main para verificacao de alguns metodos
 public static void main(String args[]){
        Console c = new Console();
 	Palavra p = new Palavra("xzracaju");
 	c.println(p.getLetra(2));
 }
}